import 'package:flutter/material.dart';

typedef Action<T> = T Function();

class Provider extends StatefulWidget {
  final Widget child;
  final Key? stateKey;
  const Provider(this.child, {Key? key, this.stateKey}) : super(key: key);
  @override
  ProviderState createState() => ProviderState();
  //(key: stateKey);
  static of(BuildContext context, dynamic model) {
    return InheritedModel.inheritFrom<_InheritedStore>(context, aspect: model);
  }
}

class ProviderState extends State<Provider> {
  dynamic aspectId;
  ProviderState({Key? key});

  void dispatch(dynamic model, [Function? action]) {
    aspectId = model;
    if (action != null) {
      action();
      setState(() => false);
      return;
    }
    setState(() => false);
    return;
  }

  @override
  Widget build(BuildContext context) {
    return _InheritedStore(child: widget.child, aspectId: aspectId as dynamic);
  }
}

class _InheritedStore extends InheritedModel<Object> {
  const _InheritedStore(
      {Key? key, required Widget child, required this.aspectId})
      : super(key: key, child: child);
  final dynamic aspectId;

  @override
  bool updateShouldNotify(_InheritedStore oldWidget) {
    return true;
  }

  @override
  bool updateShouldNotifyDependent(
      InheritedModel<dynamic> oldWidget, Set<dynamic> dependencies) {
    bool result = dependencies.contains(aspectId);
    return result;
  }
}
